package com.mortals.xhx.module.app.web;

import com.mortals.framework.annotation.UnAuth;
import com.mortals.framework.exception.AppException;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.base.system.param.service.ParamService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.ObjectUtils;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.bind.annotation.*;
import com.mortals.framework.model.Context;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.module.app.model.AppRecordEntity;
import com.mortals.xhx.module.app.service.AppRecordService;
import org.apache.commons.lang3.ArrayUtils;
import com.mortals.framework.util.StringUtils;

import java.util.*;
import java.util.stream.Collectors;

import com.alibaba.fastjson.JSONObject;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import static com.mortals.framework.ap.SysConstains.*;

import com.mortals.xhx.common.code.*;

/**
 * 应用访问记录
 *
 * @author zxfei
 * @date 2025-04-03
 */
@RestController
@RequestMapping("app/record")
public class AppRecordController extends BaseCRUDJsonBodyMappingController<AppRecordService, AppRecordEntity, Long> {

    @Autowired
    private ParamService paramService;

    public AppRecordController() {
        super.setModuleDesc("应用访问记录");
    }

    @Override
    @UnAuth
    public String save(@RequestBody AppRecordEntity entity) {
        if (ObjectUtils.isEmpty(entity.getAppName())) {
            throw new AppException("应用名称不能为空！");
        }

        if (ObjectUtils.isEmpty(entity.getAppKey())) {
            throw new AppException("应用key不能为空！");
        }
        entity.setAccessTime(new Date());
        return super.save(entity);
    }

    /*@GetMapping(value = "query")
    public String query(@RequestParam(name = "app") String app,@RequestParam(name = "key") String key) {
        JSONObject jsonObject = new JSONObject();
        String busiDesc = "保存查询" + this.getModuleDesc();
        try {

            if(ObjectUtils.isEmpty(app)){
                throw new AppException("应用名称不能为空！");
            }

            if(ObjectUtils.isEmpty(key)){
                throw new AppException("应用key不能为空！");
            }

            AppRecordEntity appRecordEntity = new AppRecordEntity();
            appRecordEntity.initAttrValue();

            appRecordEntity.setAppName(app);
            appRecordEntity.setAppKey(key);
            appRecordEntity.setAccessTime(new Date());

            appRecordEntity.setCreateTime(new Date());
            appRecordEntity.setCreateUserId(1L);

            this.service.save(appRecordEntity,getContext());

            recordSysLog(request, busiDesc + " 【成功】");
            jsonObject.put(KEY_RESULT_CODE, VALUE_RESULT_SUCCESS);
            jsonObject.put(KEY_RESULT_MSG, busiDesc + "成功！");
        } catch (Exception e) {
            log.error("获取异常", e);
            jsonObject.put(KEY_RESULT_CODE, VALUE_RESULT_FAILURE);
            jsonObject.put(KEY_RESULT_MSG, super.convertException(e));
        }
        return jsonObject.toJSONString();
    }*/

    @Override
    protected void init(Map<String, Object> model, Context context) {
        super.init(model, context);
    }


}